% PLOTTING IRFS

% % Parameters
font_size   = 12;
line_width  =2;
base_color  = [0.2 0.2 0.6];

pre_t       = 0;
pos_t       = 20;

if  parameters.shock == 'r'
    color_base2=[0.6 0.1 0.1];
    LineStyle_2 = '-.';
else
    color_base2=[0.2 0.1 0.8];
    LineStyle_2 = '-';
end

color_base =[0.1 0.1 0.6]; 
color1   =  [0.1 0.1 0.1];
color2   =  [0.5 0.5 0.5];
color3   =  [0.9 0.9 0.9];
color4   =  [0.8 0.8 0.9];
color_mat=  [color1; color2; color3; color4];



color_rss=  [0.6 0.1 0.1];
color_rss_val=  color_base2;
markersize   = 40;
LineStyle_3 = ':';
LineStyle_4 = '-.';

% Variables
dt = parameters.dt;
t         = 0:parameters.dt:parameters.t_max;    % calendar time
Debt_hrss = sum(results.f_hrss)*dt; % 
Debt      = sum(results.f_n(:,:))*dt;
Issuances =  sum(results.iota_n(:,:))*dt;
Issuances_hrss = sum(results.iota_hrss)*dt; % 
WAM_iota_hrss = sum(results.iota_hrss.*tau'*dt)/sum(results.iota_hrss*dt);
WAM_iota = zeros(size(Debt));
for i=1:length(t)
    WAM_iota(i) = sum(results.iota_n(:,i).*tau'*dt)/sum(results.iota_n(:,i)*dt);
end

% [average_duration, average_term_to_maturity] = Portfolio_duration(results, parameters, paths);
exo_hr_path_construct;
paths.r_bar_n = r_bar_n(1,:);
paths.y_n     = y_n(1,:);

figure(2)
% subplot(3,2,1)
% plot(t,paths.r_bar_n*100,'Linewidth',line_width,'Color',color_base2,'LineStyle',LineStyle_2); hold on; 
% scatter(0,parameters.r_bar_ss *100,markersize,color_base2,'o');
% plot([pre_t 0],[parameters.r_bar_ss  parameters.r_bar_ss ]*100,'Linewidth',line_width,'Color',color_base2,'LineStyle',LineStyle_2);
% plot(0,parameters.r_bar_ss *100,'*','Linewidth',line_width,'Color',color_rss_val,'MarkerSize',2);
% scatter(0,paths.r_bar_n(1)*100,markersize,color_base2,'o','filled'); 
% scatter(t(end),paths.r_bar_n(end)*100,markersize,color_base2,'>','filled'); 
% title('(a) Short-term rate, $r^*_t$','FontSize',font_size,'interpreter','latex')
% xlabel('Time, $t$ (years)','FontSize',font_size,'interpreter','latex')
% ylabel('$\%$','FontSize',font_size,'interpreter','latex')
% xlim([pre_t pos_t]); grid on;
% % legend({'$r(t)$','$r^*(t)$'},'interpreter','latex','FontSize',font_size,...
% %     'Location','Best','Box','off','Orientation','horizontal');
% 
% subplot(3,2,2)
% plot(t,results.r_n*100,'Linewidth',line_width,'Color',color_base2,'LineStyle',LineStyle_2); hold on;
% scatter(0,parameters.rho*100,markersize,color_base2,'o');
% plot([pre_t 0],[parameters.rho parameters.rho]*100,'Linewidth',line_width,'Color',color_base2);
% scatter(t(end),results.r_n(end)*100,markersize,color_base2,'>','filled'); 
% plot(0,parameters.rho*100,'*','Linewidth',line_width,'Color',color_rss_val,'MarkerSize',2);
% scatter(0,results.r_n(1)*100,markersize,color_base2,'o','filled'); 
% title('(b) Discount, $r_t$','FontSize',font_size,'interpreter','latex')
% xlabel('Time, $t$ (years)','FontSize',font_size,'interpreter','latex')
% ylabel('$\%$','FontSize',font_size,'interpreter','latex')
% xlim([pre_t pos_t]); grid on;
% 
% subplot(3,2,3)
% plot(t,paths.y_n,'Linewidth',line_width,'Color',color_base2,'LineStyle',LineStyle_2); hold on;
% scatter(0,paths.y_n(1),markersize,color_base2,'o','filled'); 
% scatter(t(end),paths.y_n(end),markersize,color_base2,'>','filled');
% plot([pre_t 0],[paths.y_n(end) paths.y_n(end)],'Linewidth',line_width,'Color',color_base2,'LineStyle',LineStyle_2);
% scatter(0,paths.y_n(end),markersize,color_base2,'o');
% plot(0,paths.y_n(end),'*','Linewidth',4,'Color',color_rss_val,'MarkerSize',2);
% grid on; xlabel('Time, $t$ (years)','FontSize',font_size,'interpreter','latex');
% title('(c) Income, $y_t$','FontSize',font_size,'interpreter','latex');
% xlim([pre_t pos_t]); 
% 
% subplot(3,2,4)
% plot(t,results.c_n,'Linewidth',line_width,'Color',color_base2,'LineStyle',LineStyle_2); hold on;
% scatter(0,results.c_n(1),markersize,color_base2,'o','filled'); 
% scatter(t(end),results.c_n(end),markersize,color_base2,'>','filled');
% plot([pre_t 0],[results.c_hrss(1) results.c_hrss(1)],'Linewidth',line_width,'Color',color_base2);
% scatter(0,results.c_hrss(1),markersize,color_base2,'o');
% plot(0,results.c_hrss(1),'*','Linewidth',4,'Color',color_rss_val,'MarkerSize',2);
% grid on; xlabel('Time, $t$ (years)','FontSize',font_size,'interpreter','latex');
% title('(d) Consumption, $c_t$','FontSize',font_size,'interpreter','latex');
% xlim([pre_t pos_t]); 
% 
% subplot(3,2,5)
fig = figure
plot(t,Issuances*100,'Linewidth',line_width,'Color',color_base2,'LineStyle',LineStyle_2); hold on;
plot([pre_t 0],[Issuances_hrss Issuances_hrss]*100,'Linewidth',line_width,'Color',color_base2);
scatter(0,Issuances_hrss*100,markersize,color_base2,'o');
plot(0,Issuances_hrss*100,'*','Linewidth',line_width,'Color',color_rss_val,'MarkerSize',2);
scatter(0,Issuances(1)*100,markersize,color_base2,'o','filled'); 
scatter(t(end),Issuances(end)*100,markersize,color_base2,'>','filled'); 
xlabel('Time, $t$ (years)','FontSize',font_size,'interpreter','latex')
ylabel('$\%$ $y_{ss}$','FontSize',font_size,'interpreter','latex')
%title('Issuances','FontSize',font_size,'interpreter','latex')
hold on; xlim([pre_t pos_t]); grid on;
orient(fig,'landscape')
set(gca,'FontSize',20)
print('principal.pdf', '-dpdf','-r800','-fillpage') 

% subplot(3,2,6)
% plot(t,WAM_iota,'Linewidth',line_width,'Color',color_base2,'LineStyle',LineStyle_2); hold on;
% plot([pre_t 0],[WAM_iota(end) WAM_iota(end)],'Linewidth',line_width,'Color',color_base2);
% scatter(0,WAM_iota(end),markersize,color_base,'o');
% plot(0,WAM_iota(end),'*','Linewidth',line_width,'Color',color_rss_val,'MarkerSize',2);
% scatter(0,WAM_iota(1),markersize,color_base2,'o','filled'); 
% scatter(t(end),WAM_iota(end),markersize,color_base2,'>','filled'); 
% xlabel('Time, $t$ (years)','FontSize',font_size,'interpreter','latex')
% ylabel('Years','FontSize',font_size,'interpreter','latex')
% title('(f) Weighted average maturity','FontSize',font_size,'interpreter','latex')
% hold on; xlim([pre_t pos_t]); grid on;
