%PLOT YIELD CURVE AND DOMESTIC DISCOUNT
fig=figure;
font_size   = 25;
[y_curve,~]= yield_curve2(results.psi_rss,parameters);
plot(tau,100*y_curve,'Linewidth',2)
hold on
plot(maturities/12,100*curve_ss,'--','marker','o','Linewidth',2)
grid
xlabel('Maturity $\tau$ (years)','FontSize',font_size,'interpreter','latex')
ylabel('$\%$','FontSize',font_size,'interpreter','latex')
%title('(a) Yield curve (market prices)','FontSize',font_size,'interpreter','latex')
ylim([0 5])
set(gca,'FontSize',20)
orient(fig,'landscape')
print('Yield_curve_panel_1.pdf', '-dpdf','-r800','-fillpage') 

fig=figure;
time_preallocate;
bond_prices = exp(-curve_ss .* tau(maturities));
valuations  = (1-issuances/dt.*parameters.lambda_bar_vec(maturities)').*bond_prices;
shadow_domestic_rates = -log(valuations)./tau(maturities);
[shadow_domestic_rates_model,~]= yield_curve2(results.v_rss,parameters);
plot(tau,100*shadow_domestic_rates_model,'Linewidth',2)
hold on
plot(maturities(6:end)/12,100*shadow_domestic_rates(6:end),'--','marker','o','Linewidth',2)
grid
xlabel('Maturity $\tau$ (years)','FontSize',font_size,'interpreter','latex')
ylabel('$\%$','FontSize',font_size-1,'interpreter','latex')
%title('(b) Yield curve (domestic valuations)','FontSize',font_size,'interpreter','latex')
ylim([0 5])
set(gca,'FontSize',20)
legend({'Model','Data'},'Box','off','FontSize',font_size,'interpreter','latex','location','best');
orient(fig,'landscape')
print('Yield_curve_panel_2.pdf', '-dpdf','-r800','-fillpage')
