%% ADDING AN EXTRA BOND
fig=figure;
load baseline;
iota_baseline = results.iota_rss(maturities);
load lower_rates;
iota_flat     = results.iota_rss(maturities);
load extra_bond;
iota_baseline = [iota_baseline ; 0];
iota_flat   = [iota_flat ; 0];
font_size   = 25;
h=bar([100*iota_baseline'*dt;100*iota_flat'*dt;100*results.iota_rss(maturities)'*dt]','EdgeColor','none');
set(gca,'xticklabel',{maturities})
h(1,1).FaceColor = [ 0.5 0.7 0.1];
h(1,2).FaceColor = [ 0.8 0.1 0.1];
h(1,3).FaceColor = [0    0.2    0.7];
set(gca,'FontSize',20)
grid
xlabel('Maturity (months)','FontSize',font_size,'interpreter','latex')
ylabel('$\%$ annual GDP ','FontSize',font_size,'interpreter','latex')
%title('Issuances','FontSize',font_size+2,'interpreter','latex')
legend({'Baseline','Lower rates','+ 50-year bond'},'Box','off','FontSize',font_size,'interpreter','latex','location','best');
xlim([5.5 11.5])
orient(fig,'landscape')
print('extra.pdf', '-dpdf','-r800','-fillpage') 