function [path_out] = solve_hr_path(hr,paths,parameters)
% solves_hr_path: solves valuatinos and probs of default for homotethic
% risk
% Inputs:
% hr: homothetic risk path (to import prices only - guesses)
% paths: path for variables (guess only)
% ---> rss: risky-steady state to use as guess
% parameters: parameters
plotit=1;

%% Model Parameters
% upack budgets
parameter_unpack    ;
time_preallocate    ;



% update solver method
solve_method=parameters.solve_method;

% Update Outer Parameters
gamma   = parameters.gamma   ; 
rho     = parameters.rho     ;  
phi     = parameters.phi     ; 
prob_mat= parameters.prob_mat;
dU      = parameters.dU;
N_r     = parameters.N_r     ;
N_y     = parameters.N_y     ;

% value of autarky
V_a=parameters.V_a;

% construct the path
% Update paths
exo_hr_path_construct  ; % output
paths.y_n=y_n       ; % output
paths.r_bar_n=r_bar_n       ; % output

%% Update Guess - Use RSS as possible guess
c_in                  = paths.c_out      ; % consumption of each possible path
c_hrss_in(1:N_r*N_y,1)= paths.rss.c_rss  ; %
J_v                   = paths.rss.J_v_rss; 
c_hrss        = c_in(:,1); % 
c_0           = c_in(:,2);
c_in          = c_in(:,2:N_t+1);
J_c_0         = c_0./c_hrss;

                
% Update guess - or value for initial prices
psi_0_mat          = hr.psi_hr_0_mat    ; % [s-->] adapt here
Phi                = hr.Phi             ; % changed to cap Phi

% Constructing a constant jump (the one in the RSS)
hr.hrss.a(1:N_r,1:N_y)= hr.a            ; % Auxiliary value 
a                     = hr.a;
hr.f_0                = paths.rss.f_rss ; % 
Prob_extend           = (prob_mat.*a)';
E_v_J                 = (ones(N_tau,1)*dU(J_c_0').*J_v)*Prob_extend(:); %

% Initial Guess
c_in = 0*c_in + c_hrss;
c_in = [c_hrss c_in];

% construct a term here...

%% Main Loop for computation of HRSS equilibrium
tic
% if parameters.hrss_update==0;
%     parameters.hrss_iter=1;
% end
for iter = 1:parameters.hrss_iter        
               
        %% [1]  Construct Deterministic path after shock using expected jump J_v
        % update key objects in iteration
%         c_hrss        = c_in(:,1); % 
%         c_0           = c_in(:,2); 
          c_in          = c_in(:,2:N_t+1);
%         J_c_0         = c_0./c_hrss;
%         Prob_extend   = (prob_mat.*a)';      
%         E_v_J         = (ones(N_tau,1)*dU(J_c_0').*J_v)*Prob_extend(:); %
                
        %% [2] Construction of rates of discount rates
        % compute the results
        paths.psi_n = hr.psi_hr_n;    % plug in path of prices, at latest update 
        path_out    = compute_hr_path(c_in,E_v_J,hr,paths,parameters); % [s*:<- important changes inside, related to phi]
 
         % Update path including hrss
%         if parameters.hrss_update==1; % If you use Saki's algorithm, we pack the results again
%             % [2.a] Solve for new HRSS 
%             r_hrss                  = rho-phi*E_v_J                                    ; % phi effect inside..
%             hrss_out=solve_hrss(hr.psi_hrss*prob_mat,0*J_v*prob_mat,r_hrss,parameters) ; % <- 0 because jump already in value...
% 
%             % [2.b] pack results
%             ii=0;
%             for rr=1:N_r
%                 for yy=1:N_y
%                     ii=ii+1;
%                     if ii==1
%                         f_out   = [hrss_out.f_hrss path_out.f_out(:,:,ii)            ];
%                         iota_out= [hrss_out.iota_hrss path_out.iota_out(:,:,ii)      ];
%                         v_out   = [hrss_out.v_hrss path_out.v_n(:,:,ii)              ];
%                         r_out   = [rho path_out.r_n(ii,:)                            ];
%                         c_out   = [hrss_out.c_hrss path_out.c_out(ii,:)              ];
%                     else
%                         f_out(:,:,ii)   = [hrss_out.f_hrss path_out.f_out(:,:,ii)      ];
%                         iota_out(:,:,ii)= [hrss_out.iota_hrss path_out.iota_out(:,:,ii)];
%                         v_out(:,:,ii)   = [hrss_out.v_hrss path_out.v_n(:,:,ii)        ];
%                         r_out(ii,:)     = [rho path_out.r_n(ii,:)                      ];
%                         c_out(ii,:)     = [hrss_out.c_hrss path_out.c_out(ii,:)                ];
%                     end
%                 end
%             end
%             hr.f_0=hrss_out.f_hrss ; % fix one because the steady states are the same...
%             
%             % Update Value Jump
%             v_hr_0_mat=[]; v_hr_term_mat=[]; ii=0;
%             for rr=1:N_r
%                 for yy=1:N_y
%                     ii=ii+1;
%                     v_hr_0_mat   = [v_hr_0_mat v_out(:,2,ii)]; 
%                     v_hr_term_mat= [v_hr_term_mat v_out(:,end,ii)]; 
%                 end 
%             end
%             J_c_0     = c_out(:,2)./c_out(:,end);
%             
%         elseif parameters.hrss_update==0
            c_out   = [c_hrss path_out.c_out   ];
            f_out   = [path_out.f_out          ];
            iota_out= [path_out.iota_out       ];
            r_out   = [path_out.r_n            ];
            v_out   = [path_out.v_n            ];
% 
%             % Update Value Jump
%             v_hr_0_mat=[]; v_hr_term_mat=[]; ii=0;
%             for rr=1:N_r
%                 for yy=1:N_y
%                     ii=ii+1;
%                     v_hr_0_mat   = [v_hr_0_mat v_out(:,2,ii)]; 
%                     v_hr_term_mat= [v_hr_term_mat v_out(:,1,ii)]; 
%                 end 
%             end
%             J_c_0     = c_out(:,2)./c_out(:,1);
%         end

        %% [3] Update Values and compute residual
%         % Update Jump -- [SB: fix indices to speed up]
%         U_J_mat   = dU(J_c_0); 
%         
%         % Construct HRSS (SB: stopped here:)
%         % v_J_0_mat = (v_hr_0_mat.*U_J_mat')*prob_mat;
%         v_J_0_mat = (v_hr_0_mat);
%         
%         % Compute Jump for next loop
%         J_v = v_J_0_mat./v_hr_term_mat;
        
        % Update consumption path
        c_in          = [c_hrss c_in];
        c_in = relax_path*c_out+(1-relax_path)*c_in;
       % V    = compute_value_functional(c_in,parameters) ;       
        
        % Check Equilibrium condition
        residual=max(max(abs(c_in./c_out-1)))                
        if iter<=max_iter          
            if residual<tol_path
                iter=max_iter+1;
                disp('Converged in less than max iterations');
                break
            end
        else
            error('Error: maximum number of iterations reached')
        end
        
        %% [4] If default is positive, update...
        % Update default value
%          if parameters.penalty <1
%             % here goes the line recomputing PHI, PHI_prime and a
%             hrss_iter.c_rss    = c_out(1,1,1); % [s*:<- DOUBLE CHECK THIS IS STEADY STATE, should be saved correctly]
%             hrss_iter.iota_rss = iota_out(:,1,1);
%             Phi     = phi_cdf(parameters,V,V_a); 
%             Phi     = reshape(Phi,[N_y N_r])'  ;
%             Phi_prime  = phi_pdf(parameters,V,V_a); % 
%             mu_rss     = solve_multiplier_rss(parameters,hrss_iter); % [s*:<- need to fix here...discuss with Galo [done]]
% 
%             % Update
%             ii=0;
%             for rr=1:N_r
%                 for yy=1:N_y
%                     ii=1+ii;       
%                       hrss.a(ii)= Phi(rr,yy) + Phi_prime(ii)*sum(mu_rss.*hr.psi_0_mat(:,rr)*dt); 
% 
%                       if parameters.mode == 3 % When Omega = 0
%                           hr.hrss.a(ii)= Phi(rr,yy); 
%                       end
%                 end
%             end         
%          end
         
         %% [5] Bond prices in rss with risk + update prices within loop, considering default risk now
        % Update prices
%         if parameters.penalty <1&&parameters.phi>0 % if you co
%             hr=compute_psi_hrss_paths(hr,Phi,paths,parameters);
%         end
        
        % Report iteration
        if mod(iter,20) == 0
            if plotit==1
                figure(101)
                plot(c_in(1,1)+0*c_in,'k--'); hold on; plot(c_in'); hold on; grid on; axis tight;
                drawnow; 
            end

            disp(iter)
            disp(residual)
        end        
end

%% Packing the results obtain from last interation
% path_out  = compute_hr_path(c_in,J_v,hr,paths,parameters);
toc
path_out.psi_hrss  = hr.psi_hrss;
% path_out.V         = V;
% path_out.Phi       = Phi;
% path_out.mu_rss    = mu_rss;
if parameters.hrss_update==1;
    % [3] Solve for new HRSS 
    r_hrss                  = rho-phi*E_v_J                                   ; % phi effect inside..
    hrss_out=solve_hrss(hr.psi_hrss*prob_mat,0*J_v*prob_mat,r_hrss,parameters); % because jump already in value...

    % [4] Update
    ii=0;
    for rr=1:N_r
        for yy=1:N_y
            ii=ii+1;
            if ii==1
                path_out.f_out(:,1:end+1,ii)   = [hrss_out.f_hrss path_out.f_out(:,:,ii)            ];
                path_out.iota_out(:,1:end+1,ii)= [hrss_out.iota_hrss path_out.iota_out(:,:,ii)      ];
                path_out.v_out(:,1:end+1,ii)   = [hrss_out.v_hrss path_out.v_n(:,:,ii)              ];
                path_out.r_out                 = [rho path_out.r_n(ii,:)                            ];
                c_out(ii,:)                    = [hrss_out.c_hrss path_out.c_out(ii,:)              ];
            else
                path_out.f_out(:,1:end,ii)   = [hrss_out.f_hrss path_out.f_out(:,1:end-1,ii)      ];
                path_out.iota_out(:,1:end,ii)= [hrss_out.iota_hrss path_out.iota_out(:,1:end-1,ii)];
                path_out.v_out(:,1:end,ii)   = [hrss_out.v_hrss path_out.v_n(:,:,ii)              ];
                path_out.r_out(ii,:)         = [rho path_out.r_n(ii,:)                            ];
                c_out(ii,:)                  = [hrss_out.c_hrss path_out.c_out(ii,:)              ];
            end
        end
    end
elseif parameters.hrss_update==0
    path_out.c_out   = [c_hrss path_out.c_out                ];    
    ii=0;
    for rr=1:N_r
        for yy=1:N_y
            ii=ii+1;
            if ii==1
                path_out.f_out(:,1:end+1,ii)   = [hr.f_0 path_out.f_out(:,:,ii)         ];
                path_out.iota_out(:,1:end+1,ii)= [hr.iota_hrss path_out.iota_out(:,:,ii)];
                path_out.v_out(:,1:end+1,ii)   = [hr.v_hrss path_out.v_n(:,:,ii)        ];
                path_out.r_out                 = [hr.r_hrss path_out.r_n(ii,:)          ];
            else
                path_out.f_out(:,1:end,ii)   = [hr.f_0 path_out.f_out(:,1:end-1,ii)         ];
                path_out.iota_out(:,1:end,ii)= [hr.iota_hrss path_out.iota_out(:,1:end-1,ii)];
                path_out.v_out(:,1:end,ii)   = [hr.v_hrss path_out.v_n(:,:,ii)              ];  
                path_out.r_out               = [hr.r_hrss path_out.r_n(ii,:)                ];
            end
        end
    end
end
   