function [hrss]=solve_hrss(psi_rss,v_0_mat,rho_adj,parameters);
% Numerical parameters
parameter_unpack;
time_preallocate;

% solve solution
rho       = rho_adj;
lambda_bar_vec= parameters.lambda_bar_vec;
delta     = parameters.delta;
y_ss      = parameters.y_ss;
Exo_Iota  = parameters.Exo_Iota ;

%% STEADY STATE
v_rss    = solve_gHJB_rss(rho,v_0_mat,parameters)   ; % HJB: Solution at Steady State
iota_rss = Exo_Iota+(Exo_Iota==0).*((1./lambda_bar_vec).*(1-v_rss./psi_rss)); % Optimal policies
f_rss     = flip(cumsum(flip(iota_rss)))*dt      ; % KFE
c_rss = y_ss  - f_rss(1) + sum((psi_rss.*(1-1/2*lambda_bar_vec.*iota_rss).*iota_rss)-delta*f_rss)*dt; % Consumption
r_rss = rho;

if c_rss<=0 % The case lambda <lambda_min
    warning('Negative Consumption at RSS');
    
%     r_ss = (r_bar + rho) /2; % First guess
%     for iter = 1:max_iter
%         v_ss     = -delta/r_ss *(1-exp(-r_ss*tau'))-exp(-r_ss*tau');
%         iota_ss  = 1./lambda_bar .*  (1-v_ss./psi_ss);% Optimal policies
%         f_rss     = flip(cumsum(flip(iota_ss)))*dt;% KFE
%         c_ss = y_ss  - f_rss(1) + sum((psi_ss - 1/2 *lambda_bar .* iota_ss).*iota_ss-delta*f_rss) * dt;% Consumption
%         if  abs(c_ss) < tol_path
%             break  % Consumption should be zero
%         else
%             r_ss = r_ss + relax_path*c_ss; 
%         end
%     end
%     if iter == max_iter
%         disp('Error: maximum number of iterations reached at steady state loop')
%     end
end
hrss.c_hrss=c_rss;
hrss.iota_hrss=iota_rss;
hrss.v_hrss=v_rss;
hrss.f_hrss=f_rss;
hrss.r_hrss=r_rss;