function [y_curve,P_0]= yield_curve2(psi,parameters)
% output:
% y_curve yield curve
% P_0 are 0 coupon prices

% Preference Parameters
delta= parameters.delta      ; % Coupon portion
dt   = parameters.dt;       % Monthly steps

%% Variables (preallocation)
[N_tau,N_t]= size(psi);     % number of time nodes
tau_vec    = dt:dt:parameters.tau_max;

% Auxiliary Structure
P_0       = zeros(N_tau,N_t);
P         = psi;
y_curve   = zeros(N_tau,N_t);
A         = tril(ones(N_tau,N_tau));
Id        = eye(N_tau);
A1        = (delta*dt*A+Id);

for i=1:N_t;
    P_0(:,i)=A1\P(:,i);
end

for i=1:N_t;
   y_curve(:,i)=-log(P_0(:,i))./tau_vec';
end









        
        
        
        


